// m26Doc.cpp : implementation of the CM26Doc class
//

#include "stdafx.h"
#include "m26.h"

#include "rodina.h"
#include "osoba.h"
#include "m26Doc.h"
#include "newosobadlg.h"
#include "seznamdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CM26Doc

IMPLEMENT_DYNCREATE(CM26Doc, CDocument)

BEGIN_MESSAGE_MAP(CM26Doc, CDocument)
	//{{AFX_MSG_MAP(CM26Doc)
	ON_COMMAND(ID_RODINA_ADDPERSON, OnRodinaAddperson)
	ON_COMMAND(ID_RODINA_SEZNAM, OnRodinaSeznam)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CM26Doc construction/destruction

CM26Doc::CM26Doc()
{
	// TODO: add one-time construction code here

}

CM26Doc::~CM26Doc()
{
}

BOOL CM26Doc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	m_rodina.Free();
	UpdateAllViews(NULL);

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CM26Doc serialization

void CM26Doc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
		Save(ar);
	}
	else
	{
		// TODO: add loading code here
		Load(ar);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CM26Doc diagnostics

#ifdef _DEBUG
void CM26Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CM26Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CM26Doc commands

void CM26Doc::OnRodinaAddperson() 
{
	// TODO: Add your command handler code here
	CNewOsobaDlg dlg;

	if(dlg.DoModal()==IDOK)
	{
		COsoba *obj=new COsoba(m_rodina.GenerateID(),dlg.m_jmeno,dlg.m_prijmeni,dlg.m_pohlavi?'Z':'M',dlg.m_narozeni,dlg.m_umrti);

		m_rodina.AddOsoba(obj);

		UpdateAllViews(NULL);
	}

}

//nacitani ze souboru
void CM26Doc::Load(CArchive &ar)
{
	CFile *file=ar.GetFile();

	DWORD length=file->GetLength();
	
	TCHAR *data=new TCHAR[length];
	if(!data)
	{
		AfxMessageBox("Nedostatek pamti pro oteven souboru");
		return;
	}

	file->Read(data,length);
	data[length-1]='\0';
	
	ParseDocument(data);

	delete[] data;


	//kontroly:
	if(!m_rodina.CheckID())
	{
		AfxMessageBox("Osoby sdileji stejny ID");
		return;
	}

	m_rodina.UpdateLinks();

	m_firstdraw=TRUE;
}

TCHAR * CM26Doc::ParseRodokmen(TCHAR *data)
{
	//rodokmen se sklada z <osoba>...</osoba>..<osoba>...</osoba>...

	TCHAR *pom=data;

	while(*pom)
	{
		TCHAR *osoba=LoadUntilTag(pom,"<osoba>");
		if(!osoba)
			return pom;

		pom=ParseOsoba(osoba);
		if(!pom)
			return NULL;

		osoba=LoadUntilTag(pom,"</osoba>");
		if(!osoba)
		{
			AfxMessageBox("Nenalezen ukoncovaci tag </osoba>");
			return NULL;
		}

		pom=osoba;
		//prazdne <osoba/> preskakujeme
	}

	AfxMessageBox("Chyba v tagu <osoba>");
	return NULL;
}

TCHAR * CM26Doc::ParseDocument(TCHAR *data)
{
	TCHAR *pom=data;

/*	TCHAR tagbuff[256];
	int tagbuffindex=0;

	BOOL istag=FALSE;
	while(*pom)
	{
		if(*pom=='<')
		{
			if(istag)
			{
				AfxMessageBox("Nalezen pebyten '<'");
				return;
			}
			istag=TRUE;
		}
		else if(*pom=='>')
		{
			if(!istag)
			{
				AfxMessageBox("Nalezen pebyten '>'");
				return;
			}
			istag=FALSE;

			tagbuff[tagbuffindex++]='\0';

			//docetli jsme tag, v dokumentu to musi byt jedine <rodokmen>
			if(_strcmpi("rodokmen",tagbuff)==0)
			{
				pom++;
				ParseRodokmen(pom);

			}
		}
		

		pom++;
	}*/

	//dokument musi obsahovat <rodokmen>...</rodokmen>

	if((pom=LoadUntilTag(pom,"<rodokmen>"))==NULL)
	{
		AfxMessageBox("Dokument neobsahuje oteviraci <rodokmen>");
		return NULL;
	}

	pom=ParseRodokmen(pom);
	if(pom==NULL)
		return NULL;

	if((pom=LoadUntilTag(pom,"</rodokmen>"))==NULL)
	{
		//AfxMessageBox("Dokument neobsahuje zaviracvi </rodokmen>");
		return NULL;
	}

	return pom;
}

TCHAR * CM26Doc::ParseTag(TCHAR *data, TCHAR *name, DWORD size)
{
	TCHAR *begin=LoadUntilTag(data,"<");
	if(!begin)
		return NULL;

	//dojdeme na konec <...> a zjidtime, jak se to uvnitr jmenuje
	TCHAR *end=strstr(begin,">");

	unsigned int len=end-begin;
	if(len>size)
		return NULL;


	strncpy(name,begin,len);
	name[1+len]='\0';



	return end+1;
}

//funkce, ktera cte, dokud nenarazi na text *tagname
TCHAR * CM26Doc::LoadUntilTag(TCHAR *data, TCHAR *tagname)
{
	TCHAR *str=strstr(data,tagname);

	if(str)
	{
		str+=strlen(tagname);
	}

	return str;
}

TCHAR * CM26Doc::ParseOsoba(TCHAR *data)
{
	COsoba *obj=new COsoba();

	//pokud neni ID, dame mu vlastni
	obj->m_id=m_rodina.GenerateID();

	while(*data)
	{
		TCHAR tagname[256];
		memset(tagname,0,256);
		
		TCHAR *temp=ParseTag(data,tagname,255);
		if(!temp)
		{
			TRACE("ParseTag(data,tagname,255); failed: \n%s\n",data);
			AfxMessageBox("Spatny format souboru");
			return NULL;
		}

		TRACE("parsing osoba: tagname=%s\n",tagname);

		if(_stricmp(tagname,"/osoba")==0)
		{
			m_rodina.AddOsoba(obj);
			return data;
		}

		if(_stricmp(tagname,"id/")==0){data=temp;continue;}
		if(_stricmp(tagname,"jmeno/")==0){data=temp;continue;}
		if(_stricmp(tagname,"prijmeni/")==0){data=temp;continue;}
		if(_stricmp(tagname,"pohlavi/")==0){data=temp;continue;}
		if(_stricmp(tagname,"narozeni/")==0){data=temp;continue;}
		if(_stricmp(tagname,"umrti/")==0){data=temp;continue;}
		if(_stricmp(tagname,"matka/")==0){data=temp;continue;}
		if(_stricmp(tagname,"otec/")==0){data=temp;continue;}

		//ted naladujeme vnitrek tagu:
		data=temp;

		TCHAR endtag[256];
		memset(endtag,0,256);
		sprintf(endtag,"</%s>",tagname);

		temp=LoadBeforeTag(data,endtag);
		if(!temp)
		{
			AfxMessageBox("Spatny format souboru");
			return NULL;
		}

		TCHAR buff[256];
		memset(buff,0,256);

		DWORD size=temp-data;
		if(size>255)size=255;

		strncpy(buff,data,size);
		buff[size]='\0';

		temp+=strlen(endtag);
		data=temp;

		TRACE("parsing osoba: endtag: %s, buff: %s\n",endtag,buff);

		if(_stricmp(tagname,"id")==0)
			obj->m_id.Format("%s",buff);
		else if(_stricmp(tagname,"jmeno")==0)
			obj->m_jmeno.Format("%s",buff);
		else if(_stricmp(tagname,"prijmeni")==0)
			obj->m_prijmeni.Format("%s",buff);
		else if(_stricmp(tagname,"pohlavi")==0)
		{
			if(buff[0]=='Z')
				obj->m_pohlavi='Z';
			else
				obj->m_pohlavi='M';
		}
		else if(_stricmp(tagname,"narozeni")==0)
		{
			obj->m_narozeni=atoi(buff);
		}
		else if(_stricmp(tagname,"umrti")==0)
		{
			obj->m_umrti=atoi(buff);
		}
		else if(_stricmp(tagname,"matka")==0)
			obj->m_matka.Format("%s",buff);
		else if(_stricmp(tagname,"otec")==0)
			obj->m_otec.Format("%s",buff);
	}

	return NULL;
}

TCHAR * CM26Doc::LoadBeforeTag(TCHAR *data, TCHAR *tagname)
{
	TCHAR *str=strstr(data,tagname);

	return str;
}

void CM26Doc::Save(CArchive &ar)
{
	ar.WriteString("<rodokmen>\n");

	POSITION pos=m_rodina.m_list.GetHeadPosition();
	while(pos!=NULL)
	{
		COsoba *obj=(COsoba *)m_rodina.m_list.GetNext(pos);

		ar.WriteString("  <osoba>\n");

		ar.WriteString("     <id>");ar.WriteString(obj->m_id);ar.WriteString("</id>\n");
		ar.WriteString("     <jmeno>");ar.WriteString(obj->m_jmeno);ar.WriteString("</jmeno>\n");
		ar.WriteString("     <prijmeni>");ar.WriteString(obj->m_prijmeni);ar.WriteString("</prijmeni>\n");

		ar.WriteString("     <pohlavi>");
		if(obj->m_pohlavi=='M')
			ar.WriteString("M");
		else
			ar.WriteString("Z");
		ar.WriteString("</pohlavi>\n");

		if(obj->m_narozeni)
		{
			ar.WriteString("     <narozeni>");
			TCHAR buff[20];
			_itoa(obj->m_narozeni,buff,10);
			ar.WriteString(buff);
			ar.WriteString("</narozeni>\n");
		}
		else
			ar.WriteString("<narozeni/>\n");

		if(obj->m_umrti)
		{
			ar.WriteString("     <umrti>");
			TCHAR buff[20];
			_itoa(obj->m_umrti,buff,10);
			ar.WriteString(buff);
			ar.WriteString("</umrti>\n");
		}
		else
			ar.WriteString("<umrti/>\n");

		ar.WriteString("     <otec>");ar.WriteString(obj->m_otec);ar.WriteString("</otec>\n");
		ar.WriteString("     <matka>");ar.WriteString(obj->m_matka);ar.WriteString("</matka>\n");

		ar.WriteString("  </osoba>\n");
	}

	ar.WriteString("</rodokmen>\n");
}

void CM26Doc::OnRodinaSeznam() 
{
	// TODO: Add your command handler code here
	CSeznamDlg dlg(&m_rodina);
	dlg.DoModal();
}
