// m26View.cpp : implementation of the CM26View class
//

#include "stdafx.h"
#include "m26.h"

#include "osoba.h"
#include "rodina.h"
#include "m26Doc.h"
#include "m26View.h"

#include "newosobadlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CM26View

IMPLEMENT_DYNCREATE(CM26View, CScrollView)

BEGIN_MESSAGE_MAP(CM26View, CScrollView)
	//{{AFX_MSG_MAP(CM26View)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CM26View construction/destruction

CM26View::CM26View()
{
	// TODO: add construction code here

}

CM26View::~CM26View()
{
}

BOOL CM26View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CM26View drawing

void CM26View::OnDraw(CDC* pDC)
{
	CM26Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here

	//nejprve nakreslime cary vztahu a ty pak preplacneme obdelniky:
	POSITION pos=pDoc->m_rodina.m_list.GetHeadPosition();
	while(pos!=NULL)
	{
		COsoba *obj=(COsoba*)pDoc->m_rodina.m_list.GetNext(pos);
	
		obj->DrawLinkParent(pDC);
		obj->DrawLinkManzel(pDC);
	}


	//projedeme cely seznam osob a nakreslime je
	pos=pDoc->m_rodina.m_list.GetTailPosition();
	while(pos!=NULL)
	{
		COsoba *obj=(COsoba*)pDoc->m_rodina.m_list.GetPrev(pos);

		obj->Draw(pDC,m_selected==obj);
	}

	if(pDoc->m_firstdraw)
	{
		CRect rect;
		GetClientRect(rect);

		pDoc->m_rodina.BuildTree(rect);
		Invalidate();

		pDoc->m_firstdraw=FALSE;
	}
}

void CM26View::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);

	m_selected=NULL;
}

/////////////////////////////////////////////////////////////////////////////
// CM26View printing

BOOL CM26View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CM26View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CM26View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CM26View diagnostics

#ifdef _DEBUG
void CM26View::AssertValid() const
{
	CScrollView::AssertValid();
}

void CM26View::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CM26Doc* CM26View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CM26Doc)));
	return (CM26Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CM26View message handlers


void CM26View::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CM26Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	//pri podrzeni CTRL se buduji rodicovske vztahy
	if(nFlags&MK_CONTROL)
	{
		//planijeme rodicovske vztahy:
		if(m_selected)
		{
			//nalezneme osobu pod kursorem:
			POSITION pos=pDoc->m_rodina.m_list.GetHeadPosition();
			while(pos!=NULL)
			{
				COsoba *obj=(COsoba*)pDoc->m_rodina.m_list.GetNext(pos);

				if(obj->IsRect(point))
				{
					//nalezli jsme osobu, rekneme vybrane osobe, ze ma rodice:
					COsoba *o1=m_selected;
					COsoba *o2=obj;

					//pokud je vybrany starsi, tak asi bude rodic sips, nez potomek
					if(o1->m_narozeni<o2->m_narozeni)
					{
						o2->AddParent(o1);
					}
					else
					{
						o1->AddParent(o2);
					}

					pDoc->m_rodina.UpdateManzele();


					break;
				}
			}

			Invalidate();
		}
	}
	else
	{
		m_selected=NULL;

		POSITION pos=pDoc->m_rodina.m_list.GetHeadPosition();
		while(pos!=NULL)
		{
			COsoba *obj=(COsoba*)pDoc->m_rodina.m_list.GetNext(pos);

			if(obj->IsRect(point))
			{
				m_selected=obj;
				break;
			}
		}
		Invalidate();
	}

	
	CScrollView::OnLButtonDown(nFlags, point);
}

void CM26View::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if(m_selected && nFlags&MK_LBUTTON   )
	{
		m_selected->MoveTo(point);

		Invalidate();		
	}
	
	CScrollView::OnMouseMove(nFlags, point);
}

void CM26View::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	CScrollView::OnLButtonUp(nFlags, point);
}

void CM26View::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CM26Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	
	POSITION pos=pDoc->m_rodina.m_list.GetHeadPosition();
	while(pos!=NULL)
	{
		COsoba *obj=(COsoba*)pDoc->m_rodina.m_list.GetNext(pos);

		if(obj->IsRect(point))
		{
			CNewOsobaDlg dlg;

			dlg.m_jmeno=obj->m_jmeno;
			dlg.m_narozeni=obj->m_narozeni;
			dlg.m_pohlavi=obj->m_pohlavi=='M'?0:1;
			dlg.m_prijmeni=obj->m_prijmeni;
			dlg.m_umrti=obj->m_umrti;

			if(dlg.DoModal()==IDOK)
			{
				obj->m_jmeno=dlg.m_jmeno;
				obj->m_narozeni=dlg.m_narozeni;
				obj->m_pohlavi=dlg.m_pohlavi?'Z':'M';
				obj->m_prijmeni=dlg.m_prijmeni;
				obj->m_umrti=dlg.m_umrti;

				obj->m_firstdraw=TRUE;

				Invalidate();
			}

			break;
		}
			
	}

	CScrollView::OnLButtonDblClk(nFlags, point);
}
